
User Interface - Bug #2452

Feature # 2252 (Closed): implement GUI client support

Feature # 2446 (Closed): implement BUTTON and IMAGE GUI widgets (runtime and conversion support)

Button label resize fails with error 4054

11/27/2014 12:13 PM - Hynek Cihlar

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Eugenie Lyzenko % Done: 0%

Category:  Estimated time: 0.00 hour

Target version: GUI Support for a Complex ADM2 App   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 11/27/2014 12:18 PM - Hynek Cihlar

def button b0.

def frame f b0.

ENABLE ALL WITH FRAME f.

b0:label = "resize".

 

The above code sample causes error "**Unable to set SCREEN-VALUE. LITERAL widget does not fit in FRAME. (4054)" in P2J, but in 4GL works

fine.

#2 - 12/04/2014 04:57 PM - Greg Shah

- Assignee set to Eugenie Lyzenko

- Start date deleted (11/27/2014)

#3 - 01/06/2015 05:47 PM - Greg Shah

- Parent task set to #2446

#4 - 03/27/2015 12:09 PM - Eugenie Lyzenko

Hynek, I need your comments.

...

+----+

|<re>|

+----+

...

** New width for BUTTON b0 is too large to fit in frame. (4475)
Procedure complete. Press space bar to continue.

...

This is the 4GL character mode output(both Linux and Windows) for the testcase you have provided. The same message I have in Windows GUI

mode(in warning dialog). Have you seen this? What do you mean telling "in 4GL works fine"?

#5 - 03/27/2015 12:48 PM - Hynek Cihlar

Indeed, the original description doesn't seem to be correct. Still there are differences between 4GL and P2J - 4GL gives the message "** New width

for BUTTON b0 is too large to fit in frame. (4475)" vs. P2J resizes the frame to fit the new label.

Eugenie, I suggest you wait with this until I finish my in-progress changes. I am modifying some of the related widget fields and logic and we would

likely get conflicts.

#6 - 03/27/2015 01:18 PM - Eugenie Lyzenko

Hynek Cihlar wrote:

Indeed, the original description doesn't seem to be correct. Still there are differences between 4GL and P2J - 4GL gives the message "** New

width for BUTTON b0 is too large to fit in frame. (4475)" vs. P2J resizes the frame to fit the new label.

 

Yes, it is exactly what I see in my tests too.

Eugenie, I suggest you wait with this until I finish my in-progress changes. I am modifying some of the related widget fields and logic and we

would likely get conflicts.

 

OK. How much time do you expect it can take?

#7 - 03/27/2015 01:36 PM - Hynek Cihlar

Eugenie Lyzenko wrote:

Eugenie, I suggest you wait with this until I finish my in-progress changes. I am modifying some of the related widget fields and logic and we

would likely get conflicts.

 

OK. How much time do you expect it can take?
I expect to have it released Monday or Tuesday.

#8 - 04/01/2015 08:27 AM - Hynek Cihlar

Eugenie, I'm bit delayed. I am expecting the work to be finished sometime at the end of the week.

#9 - 04/29/2015 09:36 AM - Greg Shah

This task can be worked on now.

#10 - 04/29/2015 12:32 PM - Eugenie Lyzenko

Greg Shah wrote:

This task can be worked on now.

 

OK. Soon I will have the fix. Can I include it into update pending to be tested and related to prepackaged button images?

#11 - 04/29/2015 12:39 PM - Greg Shah

Yes, it is a good idea to include it in the #2545 update.

#12 - 04/29/2015 02:11 PM - Eugenie Lyzenko

- File evl_upd20150429b.zip added

This update for review has fix for button resizing. I have modified ButtonWidget class adding override for GenericWidget.setLabel(String) where the

label is set for all widgets to avoid additional class casting and instanceof checking to have the code more clear.

#13 - 04/29/2015 02:19 PM - Greg Shah

Code Review evl_upd20150429b.zip

Does the 4GL remove the & characters from the label before it calculates that the label is too big to fit?  See GenericWidget.setLabel(String) which

does the removal.  That code is called after the ButtonWidget.setLabel(String) has already generated an error.  I just want to make sure we are

compatible.

Hynek: are you OK with the ButtonWidget.setLabel(String) code?

#14 - 04/29/2015 02:39 PM - Eugenie Lyzenko

- File evl_upd20150429c.zip added

Does the 4GL remove the & characters from the label before it calculates that the label is too big to fit? See GenericWidget.setLabel(String)

which does the removal. That code is called after the ButtonWidget.setLabel(String) has already generated an error. I just want to make sure we

are compatible.
Yes, you are right, the progress removes & before truncating the label. The attached update resolve this issue.

#15 - 04/29/2015 03:01 PM - Greg Shah

Code Review evl_upd20150429c.zip

I like your original idea of avoiding more type checking in GenericWidget.setLabel(), but we already have other references to ButtonWidget and

ToggleBoxWidget there.

I guess your solution is OK for now.  Eventually we should provide protected methods in GenericWidget that would allow sub-classes to override the

default behavior and thus move the button/toggle-box specific logic into those classes.

Please add a TODO in that method to explain this so that we can "remember" it easily.

#16 - 04/29/2015 03:17 PM - Eugenie Lyzenko

- File evl_upd20150429d.zip added

Greg Shah wrote:

Please add a TODO in that method to explain this so that we can "remember" it easily.

 

Adding TODO note to the GenericWidget.setLabel() change.

#17 - 04/29/2015 03:36 PM - Greg Shah

Code Review evl_upd20150429d.zip

It is good.

Hynek: any concerns?

#18 - 04/29/2015 03:37 PM - Hynek Cihlar

GenericWidget.setLabel() is becoming a little overblown. It should be split into several parts - label validation, label value transformation (removal of

'&' for example) and calculation. These parts could be abstracted and so the casting in the parent class avoided.

#19 - 04/29/2015 03:52 PM - Hynek Cihlar

Greg Shah wrote:

Code Review evl_upd20150429d.zip

It is good.

Hynek: any concerns?
I think it is good, I didn't spot any issues in the drawing code. I would maybe inline LogicalTerminal.isButtonOrImage and LogicalTerminal.isButton -

matter of personal taste.

#20 - 04/29/2015 04:03 PM - Greg Shah

OK, let's go with this as is for now.

Pause testing on this until Constantin's changes are checked in.  Then merge and regression test.

#21 - 04/29/2015 04:22 PM - Eugenie Lyzenko

- File evl_upd20150429e.zip added

OK, let's go with this as is for now.

 

Before I've got this message I prepared one more improved version of the same functionality with moving the real worker to the ButtonWidget. Sorry,

too many stages.

Pause testing on this until Constantin's changes are checked in. Then merge and regression test.

 

OK.

#22 - 04/30/2015 10:31 AM - Greg Shah

Code Review evl_upd20150429e.zip

I like it!

#23 - 05/04/2015 09:48 AM - Eugenie Lyzenko

The fix for this issue is included into update for task #2545 for commit and distribute, evl_upd20150503a.zip. Passed the runtime regression testing.

#24 - 05/04/2015 10:01 AM - Greg Shah

- Target version set to Milestone 12

- Status changed from New to Closed
#25 - 11/16/2016 12:12 PM - Greg Shah

- Target version changed from Milestone 12 to GUI Support for a Complex ADM2 App

Files

evl_upd20150429b.zip 260 KB 04/29/2015 Eugenie Lyzenko

evl_upd20150429c.zip 274 KB 04/29/2015 Eugenie Lyzenko

evl_upd20150429d.zip 275 KB 04/29/2015 Eugenie Lyzenko

evl_upd20150429e.zip 275 KB 04/29/2015 Eugenie Lyzenko
